package com.podpoint.pptmapview;


import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.bridge.ReactContextBaseJavaModule;
import com.google.android.gms.common.GoogleApiAvailability;

import java.util.HashMap;
import java.util.Map;

public class PPTGoogleMapModule extends ReactContextBaseJavaModule {

    /**
     * Constructor for this module.
     *
     * @param reactContext
     */
    public PPTGoogleMapModule(ReactApplicationContext reactContext) {
        super(reactContext);
    }

    /**
     * Returns the name of this module.
     *
     * @return String
     */
    @Override
    public String getName() {
        return "PPTGoogleMapManager";
    }

    /**
     * Exports any constants we require to the javascript layer.
     *
     * @return Map
     */
    @Override
    public Map<String, Object> getConstants() {
        final Map<String, Object> constants = new HashMap<>();

        constants.put(
                "legalNotice", GoogleApiAvailability.getInstance()
                                                    .getOpenSourceSoftwareLicenseInfo(
                                                            getReactApplicationContext()
                                                    )
        );

        return constants;
    }
}
