package com.podpoint.pptmapview;

import com.facebook.react.ReactPackage;
import com.facebook.react.bridge.JavaScriptModule;
import com.facebook.react.bridge.NativeModule;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.uimanager.ViewManager;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class PPTGoogleMapPackage implements ReactPackage {

    /**
     * Registers any react native modules that have been built.
     *
     * @param reactContext
     * @return List<NativeModule>
     */
    @Override
    public List<NativeModule> createNativeModules(ReactApplicationContext reactContext) {
        List<NativeModule> modules = new ArrayList<>();

        modules.add(new PPTGoogleMapModule(reactContext));

        return modules;
    }

    /**
     * Registers any JavaScript modules that have been built.
     *
     * @return List<Class<? extends JavaScriptModule>>
     */
    @Override
    public List<Class<? extends JavaScriptModule>> createJSModules() {
        return Arrays.asList();
    }

    /**
     * Registers any view managers that have been built.
     *
     * @param reactContext
     * @return List<ViewManager>
     */
    @Override
    public List<ViewManager> createViewManagers(ReactApplicationContext reactContext) {
        List<ViewManager> managers = new ArrayList<>();

        managers.add(new PPTGoogleMapManager());

        return managers;
    }
}
